Bug 109457 - libaio DSO has text relocation
libaio DSO has text relocation
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: libaio (Show other bugs)
3.0
i686 Linux
medium Severity low
: ---
: ---
Assigned To: Jeffrey Moyer
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-11-07 18:42 EST by Ulrich Drepper
Modified: 2007-11-30 17:06 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-08-26 03:42:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Patch to fix the problem (2.93 KB, patch)
2003-11-07 18:43 EST, Ulrich Drepper
no flags Details | Diff
change libaio to use syscall(2) (18.17 KB, patch)
2004-02-24 17:04 EST, Jeffrey Moyer
no flags Details | Diff

  None (edit)
Description Ulrich Drepper 2003-11-07 18:42:51 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.6a)
Gecko/20031105 Firebird/0.7+

Description of problem:
The libaio DSO has a text relocation.  The author had some problems
with getting syscall wrapper compiled with -fpic so he disabled it. 
Shame!

Version-Release number of selected component (if applicable):
libaio-0.3.96-3

How reproducible:
Always

Steps to Reproduce:
1.eu-readelf -d /usr/lib/libaio.so.1 | fgrep TEXTREL
2.
3.
    

Actual Results:    TEXTREL


Expected Results:  No output

Additional info:
Comment 1 Ulrich Drepper 2003-11-07 18:43:50 EST
Created attachment 95808 [details]
Patch to fix the problem

Haven't done much testing but the code passed visual inspection.
Comment 2 Jeffrey Moyer 2004-02-24 17:04:05 EST
Created attachment 98017 [details]
change libaio to use syscall(2)

This patch gets rid of the inline assembler and changes it to use syscall(2). 
I've also added the -fpic as suggested by Uli.	Uli, does this fix the problem
equally as well?
Comment 3 Ulrich Drepper 2004-02-25 01:51:37 EST
The patch looks OK.  Using syscall() is a little bit less efficient
but the costs vanish compared to the syscall cost itself.  I haven't
tested the patch but if it builds on all archs and the test using
readelf described in the report everything should be fine.
Comment 4 Ulrich Drepper 2004-08-26 03:42:25 EDT
The second patch is in the current release (0.3.99).

Note You need to log in before you can comment on or make changes to this bug.